/*
 * M2M_atParser.c
 *
 *  Created on: 04/nov/2015
 *      Author: robertaga
 */
#include <stdio.h>
#include <string.h>

#include "m2m_type.h"
#include "m2m_hw_api.h"
#include "m2m_os_api.h"
#include "m2m_os_lock_api.h"
#include "m2m_timer_api.h"


#include "m2m_utilities.h"

M2M_T_TIMER_HANDLE reg_timer = NULL;
UINT8 count = 0;


INT32 M2M_atParserProc(INT32 type, INT32 param1, INT32 param2);

void reg_wait_timer(void *arg)
{
	m2m_os_iat_send_at_command("AT+CREG?\r",1);
}

/* =================================================================================================
 *
 * DESCRIPTION:     Handles events sent to process AT_Parser
 *
 * PARAMETERS:      type:	event id
 *                  param1: addition info
 *                  param2: addition info
 *
 * RETURNS:         None.
 *
 * PRE-CONDITIONS:  None.
 *
 * POST-CONDITIONS: None.
 *
 * ============================================================================================== */

INT32 M2M_atParserProc(INT32 type, INT32 param1, INT32 param2)
{
INT32 len = param2;
CHAR *p_serStr = NULL;


    p_serStr = m2m_os_mem_alloc((len + 1) * sizeof(CHAR));
    strncpy(p_serStr, (CHAR *)param1, len);
    p_serStr[len] = 0;

    if (reg_timer == NULL)
    	reg_timer = m2m_timer_create(reg_wait_timer, (void*)0x01);


    if (strstr(p_serStr, "RING") > 0) {
    	if (count == 2) {
    		m2m_os_sleep_ms(1000);
    		m2m_os_iat_send_at_command("ATH\r",1);
    		count = 0;
    	}
    	LOG_INFO("Module out of power saving\r\n");
    	count++;
    }

    if (strstr(p_serStr, "OK") > 0) {
        	LOG_INFO(p_serStr);
    }

    if(strstr(p_serStr,"+CREG: 0,1") > 0)
	{
    	LOG_INFO("Module registered +CREG\r\n");
    	m2m_timer_free(reg_timer);
    	m2m_os_sleep_ms(1000);
    	m2m_os_send_message_to_task(1, 0, 0, 0);

	} else
	    m2m_timer_start(reg_timer, 10000);



  return 0;
}
